<template>
<div class="menu">
	<lobby
		:v-if="this.host !== null"
		:host="this.host"
		:hosting="this.is_host"
		:map="this.map"
		:messages="this.messages"
		:mode="this.mode"
		:name="this.name"
		:players="this.players"
		:teams="this.teams"
		:teamsize="this.max_players"
	/>
</div>
</template>

<script>
import Lobby from "../components/Lobby.vue"

export default {
	components: { Lobby },
	computed: {
		is_host () {
			return this.host === Networker.id
		}
	},
	data () {
		return {
			host: null,
			map: null,
			max_players: 0,
			mode: null,
			messages: [],
			name: "",
			players: [],
			teams: null
		}
	},
	mounted () {
		Networker.setCallbacks({
			onData: (data) => {
				switch (data.action) {
					case "START_GAME":
						StateManager.change(States.OnlineGame, [data])
						break
					default:
						break
				}
			},
			onUpdate: (data) => {
				Object.keys(data).forEach((key) => { this[key] = data[key] })
			}
		})
		Networker.joinRoom(this.id)
	},
	name: "lobby-state",
	props: [ "id" ]
}
</script>

<style lang="less" scoped>
@import "./styles/Menu.less";

.menu {
	width: 60em;
}

.lobby-state {
	font-size: 4em;
}
</style>
